Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs	(revision 3011)
@@ -40,4 +40,5 @@
 using HeuristicLab.Tracing;
 using Linq = HeuristicLab.Hive.Server.LINQDataAccess;
+using System.Transactions;
 
 namespace HeuristicLab.Hive.Server.Core {
@@ -57,10 +58,8 @@
       new ReaderWriterLockSlim(LockRecursionPolicy.SupportsRecursion);
 
-    private ISessionFactory factory;
+    //private ISessionFactory factory;
     private ILifecycleManager lifecycleManager;
     private IInternalJobManager jobManager;
-    private IScheduler scheduler;
-
-    Linq.ClientDao clientDao = new Linq.ClientDao();
+    private IScheduler scheduler;    
 
     private static int PENDING_TIMEOUT = 100;
@@ -72,5 +71,5 @@
     /// </summary>
     public ClientCommunicator() {
-      factory = ServiceLocator.GetSessionFactory();
+      //factory = ServiceLocator.GetSessionFactory();
 
       lifecycleManager = ServiceLocator.GetLifecycleManager();
@@ -90,32 +89,27 @@
     /// <param name="e"></param>
     void lifecycleManager_OnServerHeartbeat(object sender, EventArgs e) {
-      ISession session = factory.GetSessionForCurrentThread();
-      ITransaction tx = null;
-
       HiveLogger.Info(this.ToString() + ": Server Heartbeat ticked");
 
-      try {
-        IClientAdapter clientAdapter =
-          session.GetDataAdapter<ClientInfo, IClientAdapter>();
-        IJobAdapter jobAdapter =
-          session.GetDataAdapter<Job, IJobAdapter>();
-
-        tx = session.BeginTransaction();
-
-        List<ClientInfo> allClients = new List<ClientInfo>(clientAdapter.GetAll());
-
-        foreach (ClientInfo client in allClients) {
+      using (TransactionScope scope = new TransactionScope()) {
+
+        List<ClientDto> allClients = new List<ClientDto>(DaoLocator.ClientDao.FindAll());
+
+        foreach (ClientDto client in allClients) {
           if (client.State != State.offline && client.State != State.nullState) {
             heartbeatLock.EnterUpgradeableReadLock();
 
             if (!lastHeartbeats.ContainsKey(client.Id)) {
-              HiveLogger.Info(this.ToString() + ": Client " + client.Id + " wasn't offline but hasn't sent heartbeats - setting offline");
+              HiveLogger.Info(this.ToString() + ": Client " + client.Id +
+                              " wasn't offline but hasn't sent heartbeats - setting offline");
               client.State = State.offline;
-              clientAdapter.Update(client);
-              HiveLogger.Info(this.ToString() + ": Client " + client.Id + " wasn't offline but hasn't sent heartbeats - Resetting all his jobs");
-              foreach (Job job in jobAdapter.GetActiveJobsOf(client)) {                
+              DaoLocator.ClientDao.Update(client);
+              //clientAdapter.Update(client);
+              HiveLogger.Info(this.ToString() + ": Client " + client.Id +
+                              " wasn't offline but hasn't sent heartbeats - Resetting all his jobs");
+              foreach (JobDto job in DaoLocator.JobDao.FindActiveJobsOfClient(client)) {
                 jobManager.ResetJobsDependingOnResults(job);
               }
-            } else {
+            }
+            else {
               DateTime lastHbOfClient = lastHeartbeats[client.Id];
 
@@ -125,5 +119,5 @@
                 // if client calculated jobs, the job must be reset
                 HiveLogger.Info(this.ToString() + ": Client timed out and is on RESET");
-                foreach (Job job in jobAdapter.GetActiveJobsOf(client)) {
+                foreach (JobDto job in DaoLocator.JobDao.FindActiveJobsOfClient(client)) {
                   jobManager.ResetJobsDependingOnResults(job);
                   lock (newAssignedJobs) {
@@ -135,5 +129,7 @@
                 // client must be set offline
                 client.State = State.offline;
-                clientAdapter.Update(client);
+
+                //clientAdapter.Update(client);
+                DaoLocator.ClientDao.Update(client);
 
                 heartbeatLock.EnterWriteLock();
@@ -144,5 +140,6 @@
 
             heartbeatLock.ExitUpgradeableReadLock();
-          } else {
+          }
+          else {
             //TODO: RLY neccesary?
             //HiveLogger.Info(this.ToString() + ": Client " + client.Id + " has wrong state: Shouldn't have offline or nullstate, has " + client.State);
@@ -151,5 +148,5 @@
             if (lastHeartbeats.ContainsKey(client.Id))
               lastHeartbeats.Remove(client.Id);
-            foreach (Job job in jobAdapter.GetActiveJobsOf(client)) {
+            foreach (JobDto job in DaoLocator.JobDao.FindActiveJobsOfClient(client)) {
               jobManager.ResetJobsDependingOnResults(job);
             }
@@ -157,28 +154,20 @@
           }
         }
-        CheckForPendingJobs(jobAdapter);
-
-        tx.Commit();
-      }
-      catch (Exception ex) {
-        if (tx != null)
-          tx.Rollback();
-        throw ex;
-      }
-      finally {
-        if (session != null)
-          session.EndSession();
-      }
-    }
-
-    private void CheckForPendingJobs(IJobAdapter jobAdapter) {
-      IList<Job> pendingJobsInDB = new List<Job>(jobAdapter.GetJobsByState(State.pending));
-
-      foreach (Job currJob in pendingJobsInDB) {
+        CheckForPendingJobs();
+        DaoLocator.DestroyContext();
+        scope.Complete();        
+      }
+    }
+
+    private void CheckForPendingJobs() {
+      IList<JobDto> pendingJobsInDB = new List<JobDto>(DaoLocator.JobDao.GetJobsByState(State.pending));
+
+      foreach (JobDto currJob in pendingJobsInDB) {
         lock (pendingJobs) {
           if (pendingJobs.ContainsKey(currJob.Id)) {
             if (pendingJobs[currJob.Id] <= 0) {
               currJob.State = State.offline;
-              jobAdapter.Update(currJob);
+              DaoLocator.JobDao.Update(currJob);
+              //jobAdapter.Update(currJob);
             } else {
               pendingJobs[currJob.Id]--;
@@ -197,5 +186,5 @@
     /// <param name="clientInfo"></param>
     /// <returns></returns>
-    public Response Login(ClientInfo clientInfo) {
+    public Response Login(ClientDto clientInfo) {
     //  ISession session = factory.GetSessionForCurrentThread();
     //  ITransaction tx = null;
@@ -219,9 +208,8 @@
         clientInfo.State = State.idle;
 
-        if (clientDao.FindById(clientInfo.Id) == null)
-          clientDao.Insert(clientInfo); 
-        else 
-          clientDao.Update(clientInfo);
-        //clientAdapter.Update(clientInfo);
+        if (DaoLocator.ClientDao.FindById(clientInfo.Id) == null)
+          DaoLocator.ClientDao.Insert(clientInfo); 
+        else
+          DaoLocator.ClientDao.Update(clientInfo);        
         response.Success = true;
         response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_LOGIN_SUCCESS;
@@ -250,19 +238,19 @@
     public ResponseHB ProcessHeartBeat(HeartBeatData hbData) {
       
-      ISession session = factory.GetSessionForCurrentThread();
-      ITransaction tx = null;
+     /* ISession session = factory.GetSessionForCurrentThread();
+      ITransaction tx = null;*/
 
       HiveLogger.Info(this.ToString() + ": BEGIN Processing Heartbeat for Client " + hbData.ClientId);
 
-      try {
+      //try {
         HiveLogger.Info(this.ToString() + ": BEGIN Fetching Adapters");
-        IClientAdapter clientAdapter =
-          session.GetDataAdapter<ClientInfo, IClientAdapter>();
+      /*  IClientAdapter clientAdapter =
+          session.GetDataAdapter<ClientDto, IClientAdapter>();
 
         IJobAdapter jobAdapter =        
-          session.GetDataAdapter<Job, IJobAdapter>();
+          session.GetDataAdapter<JobDto, IJobAdapter>(); */
         HiveLogger.Info(this.ToString() + ": END Fetched Adapters");
         HiveLogger.Info(this.ToString() + ": BEGIN Starting Transaction");
-        tx = session.BeginTransaction();
+        //tx = session.BeginTransaction();
         HiveLogger.Info(this.ToString() + ": END Started Transaction");
 
@@ -271,5 +259,5 @@
 
         HiveLogger.Info(this.ToString() + ": BEGIN Started Client Fetching");
-        ClientInfo client = clientAdapter.GetById(hbData.ClientId);
+        ClientDto client = DaoLocator.ClientDao.FindById(hbData.ClientId);
         HiveLogger.Info(this.ToString() + ": END Finished Client Fetching");
         // check if the client is logged in
@@ -311,13 +299,13 @@
 
         HiveLogger.Info(this.ToString() + ": BEGIN Processing Heartbeat Jobs");
-        processJobProcess(hbData, jobAdapter, clientAdapter, response);
+        processJobProcess(hbData, response);
         HiveLogger.Info(this.ToString() + ": END Processed Heartbeat Jobs");
         
-        clientAdapter.Update(client);
-
-        tx.Commit();
+        DaoLocator.ClientDao.Update(client);
+
+        //tx.Commit();
         HiveLogger.Info(this.ToString() + ": END Processed Heartbeat for Client " + hbData.ClientId);
         return response;
-      }
+      } /*
       catch (Exception ex) {
         if (tx != null)
@@ -328,6 +316,6 @@
         if (session != null)
           session.EndSession();
-      }
-    }
+      }   
+    }     */
 
     /// <summary>
@@ -338,9 +326,9 @@
     /// <param name="clientAdapter"></param>
     /// <param name="response"></param>
-    private void processJobProcess(HeartBeatData hbData, IJobAdapter jobAdapter, IClientAdapter clientAdapter, ResponseHB response) {
+    private void processJobProcess(HeartBeatData hbData, ResponseHB response) {
       HiveLogger.Info(this.ToString() + " processJobProcess: Started for Client " + hbData.ClientId);      
       
       if (hbData.JobProgress != null && hbData.JobProgress.Count > 0) {
-        List<Job> jobsOfClient = new List<Job>(jobAdapter.GetActiveJobsOf(clientAdapter.GetById(hbData.ClientId)));
+        List<JobDto> jobsOfClient = new List<JobDto>(DaoLocator.JobDao.FindActiveJobsOfClient(DaoLocator.ClientDao.FindById(hbData.ClientId)));
         if (jobsOfClient == null || jobsOfClient.Count == 0) {
           response.Success = false;
@@ -351,5 +339,6 @@
 
         foreach (KeyValuePair<Guid, double> jobProgress in hbData.JobProgress) {
-          Job curJob = jobAdapter.GetById(jobProgress.Key);
+          JobDto curJob = DaoLocator.JobDao.FindById(jobProgress.Key);
+          curJob.Client = DaoLocator.ClientDao.GetClientForJob(curJob.Id);
           if (curJob.Client == null || curJob.Client.Id != hbData.ClientId) {
             response.Success = false;
@@ -370,7 +359,7 @@
             }
           }
-          jobAdapter.Update(curJob);
-        }
-        foreach (Job currJob in jobsOfClient) {
+          DaoLocator.JobDao.Update(curJob);
+        }
+        foreach (JobDto currJob in jobsOfClient) {
           bool found = false;
           foreach (Guid jobId in hbData.JobProgress.Keys) {
@@ -389,5 +378,5 @@
 
                   currJob.State = State.offline;
-                  jobAdapter.Update(currJob);
+                  DaoLocator.JobDao.Update(currJob);
 
                   response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, currJob.Id));
@@ -398,5 +387,5 @@
                 HiveLogger.Error(this.ToString() + " processJobProcess: Job ID wasn't with the heartbeats:  " + currJob);                      
                 currJob.State = State.offline;
-                jobAdapter.Update(currJob);
+                DaoLocator.JobDao.Update(currJob);
               }
             } // lock
@@ -420,5 +409,5 @@
     /// <param name="clientId"></param>
     /// <returns></returns>
-    public ResponseSerializedJob SendSerializedJob(Guid clientId) {
+    /*public ResponseSerializedJob SendSerializedJob(Guid clientId) {
       ISession session = factory.GetSessionForCurrentThread();
       ITransaction tx = null;
@@ -426,5 +415,5 @@
       try {
         IJobAdapter jobAdapter =
-          session.GetDataAdapter<Job, IJobAdapter>();
+          session.GetDataAdapter<JobDto, IJobAdapter>();
 
         tx = session.BeginTransaction();
@@ -432,5 +421,5 @@
         ResponseSerializedJob response = new ResponseSerializedJob();
 
-        Job job2Calculate = scheduler.GetNextJobForClient(clientId);
+        JobDto job2Calculate = scheduler.GetNextJobForClient(clientId);
         if (job2Calculate != null) {
           SerializedJob computableJob =
@@ -465,5 +454,5 @@
           session.EndSession();
       }
-    }
+    }     */
 
     /// <summary>
@@ -474,45 +463,28 @@
     /// <returns></returns>
     public ResponseJob SendJob(Guid clientId) {
-      ISession session = factory.GetSessionForCurrentThread();
-      ITransaction tx = null;
-
-      try {
-        IJobAdapter jobAdapter =
-          session.GetDataAdapter<Job, IJobAdapter>();
-
-        tx = session.BeginTransaction();
-
-        ResponseJob response = new ResponseJob();
-
-        Job job2Calculate = scheduler.GetNextJobForClient(clientId);
-        if (job2Calculate != null) {
-          response.Job = job2Calculate;
-          response.Success = true;
-          HiveLogger.Info(this.ToString() + " SendSerializedJob: Job pulled: " + job2Calculate + " for user " + clientId);                      
-          response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_JOB_PULLED;
-          lock (newAssignedJobs) {
-            if (!newAssignedJobs.ContainsKey(job2Calculate.Id))
-              newAssignedJobs.Add(job2Calculate.Id, ApplicationConstants.JOB_TIME_TO_LIVE);
-          }
-        } else {
-          response.Success = false;
-          response.Job = null;
-          response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_NO_JOBS_LEFT;
-          HiveLogger.Info(this.ToString() + " SendSerializedJob: No more Jobs left for " + clientId);                      
-        }
-
-        tx.Commit();
-
-        return response;
-      }
-      catch (Exception ex) {
-        if (tx != null)
-          tx.Rollback();
-        throw ex;
-      }
-      finally {
-        if (session != null)
-          session.EndSession();
-      }
+
+      ResponseJob response = new ResponseJob();
+
+      JobDto job2Calculate = scheduler.GetNextJobForClient(clientId);
+      if (job2Calculate != null) {
+        response.Job = job2Calculate;
+        response.Success = true;
+        HiveLogger.Info(this.ToString() + " SendSerializedJob: Job pulled: " + job2Calculate + " for user " + clientId);
+        response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_JOB_PULLED;
+        lock (newAssignedJobs) {
+          if (!newAssignedJobs.ContainsKey(job2Calculate.Id))
+            newAssignedJobs.Add(job2Calculate.Id, ApplicationConstants.JOB_TIME_TO_LIVE);
+        }
+      }
+      else {
+        response.Success = false;
+        response.Job = null;
+        response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_NO_JOBS_LEFT;
+        HiveLogger.Info(this.ToString() + " SendSerializedJob: No more Jobs left for " + clientId);
+      }
+
+
+
+      return response;
     }
 
@@ -523,10 +495,9 @@
       HiveLogger.Info(this.ToString() + " ProcessJobResult: BEGIN Job received for Storage - main method:");
       
-      ISession session = factory.GetSessionForCurrentThread();
-      ITransaction tx = null;
+     
       Stream jobResultStream = null;
       Stream jobStream = null;
 
-      try {
+      //try {
         BinaryFormatter formatter =
           new BinaryFormatter();
@@ -538,5 +509,5 @@
         //otherwise race conditions could occur when writing the stream into the DB
         //just removed TransactionIsolationLevel.RepeatableRead
-        tx = session.BeginTransaction();
+        //tx = session.BeginTransaction();
 
         ResponseResultReceived response =
@@ -550,49 +521,17 @@
 
         if (response.Success) {
-          //second deserialize the BLOB
-          IJobResultsAdapter jobResultsAdapter =
-            session.GetDataAdapter<JobResult, IJobResultsAdapter>();
-
-          IJobAdapter jobAdapter =
-            session.GetDataAdapter<Job, IJobAdapter>();
-
-          jobResultStream =
-            jobResultsAdapter.GetSerializedJobResultStream(response.JobResultId, true);
-
-          jobStream =
-            jobAdapter.GetSerializedJobStream(result.JobId, true);
+          jobStream = DaoLocator.JobDao.GetSerializedJobStream(result.JobId);
 
           byte[] buffer = new byte[3024];
           int read = 0;
-          while ((read = stream.Read(buffer, 0, buffer.Length)) > 0) {
-            jobResultStream.Write(buffer, 0, read);
+          while ((read = stream.Read(buffer, 0, buffer.Length)) > 0) {            
             jobStream.Write(buffer, 0, read);
           }
-
-          jobResultStream.Close();
-          jobStream.Close();
-
-          tx.Commit();
-        }
+          jobStream.Close();          
+        }                   
         HiveLogger.Info(this.ToString() + " ProcessJobResult: END Job received for Storage:");
         return response;
       }
-      catch (Exception ex) {
-        HiveLogger.Error(this.ToString() + " ProcessJobResult: Exception raised: " + ex);
-        if (tx != null)
-          tx.Rollback();
-        throw ex;
-      }
-      finally {
-        if (jobStream != null)
-          jobStream.Dispose();
-
-        if (jobResultStream != null)
-          jobResultStream.Dispose();
-
-        if (session != null)
-          session.EndSession();
-      }
-    }
+
 
     private ResponseResultReceived ProcessJobResult(Guid clientId,
@@ -605,22 +544,7 @@
       HiveLogger.Info(this.ToString() + " ProcessJobResult: BEGIN Job received for Storage - SUB method: " + jobId);
 
-      ISession session = factory.GetSessionForCurrentThread();
-            
-      ITransaction tx = null;
-
-      try {
-        IClientAdapter clientAdapter =
-          session.GetDataAdapter<ClientInfo, IClientAdapter>();
-        IJobAdapter jobAdapter =
-          session.GetDataAdapter<Job, IJobAdapter>();
-        IJobResultsAdapter jobResultAdapter =
-          session.GetDataAdapter<JobResult, IJobResultsAdapter>();
-        
-        //should fetch the existing transaction        
-        tx = session.BeginTransaction();
-
         ResponseResultReceived response = new ResponseResultReceived();
-        ClientInfo client =
-          clientAdapter.GetById(clientId);
+        ClientDto client =
+          DaoLocator.ClientDao.FindById(clientId);
 
         SerializedJob job =
@@ -629,5 +553,6 @@
         if (job != null) {
           job.JobInfo =
-            jobAdapter.GetById(jobId);
+            DaoLocator.JobDao.FindById(jobId);          
+          job.JobInfo.Client = job.JobInfo.Client = DaoLocator.ClientDao.GetClientForJob(jobId);
         }
 
@@ -639,5 +564,5 @@
           HiveLogger.Error(this.ToString() + " ProcessJobResult: No job with Id " + jobId);                      
           
-          tx.Rollback();
+          //tx.Rollback();
           return response;
         }
@@ -648,5 +573,5 @@
           HiveLogger.Error(this.ToString() + " ProcessJobResult: Job was aborted! " + job.JobInfo);                      
           
-          tx.Rollback();
+          //tx.Rollback();
           return response;
         }
@@ -658,5 +583,5 @@
           HiveLogger.Error(this.ToString() + " ProcessJobResult: Job is not being calculated (client = null)! " + job.JobInfo);                      
 
-          tx.Rollback();
+          //tx.Rollback();
           return response;
         }
@@ -668,5 +593,5 @@
           HiveLogger.Error(this.ToString() + " ProcessJobResult: Wrong Client for this Job! " + job.JobInfo + ", Sending Client is: " + clientId);                      
 
-          tx.Rollback();
+          //tx.Rollback();
           return response;
         }
@@ -678,5 +603,5 @@
           HiveLogger.Error(this.ToString() + " ProcessJobResult: Job already finished! " + job.JobInfo + ", Sending Client is: " + clientId);                      
 
-          tx.Rollback();
+          //tx.Rollback();
           return response;
         }
@@ -692,5 +617,5 @@
           HiveLogger.Error(this.ToString() + " ProcessJobResult: Wrong Job State, job is: " + job.JobInfo);                      
 
-          tx.Rollback();
+          //tx.Rollback();
           return response;
         }
@@ -702,44 +627,15 @@
 
         job.SerializedJobData = result;
-        jobAdapter.UpdateSerializedJob(job);
-
-        List<JobResult> jobResults = new List<JobResult>(
-          jobResultAdapter.GetResultsOf(job.JobInfo.Id));
-        foreach (JobResult currentResult in jobResults)
-          jobResultAdapter.Delete(currentResult);
-
-        SerializedJobResult serializedjobResult =
-          new SerializedJobResult();
-        JobResult jobResult = new JobResult();
-        jobResult.ClientId = client.Id;
-        jobResult.JobId = job.JobInfo.Id;
-        jobResult.Percentage = percentage;
-        jobResult.Exception = exception;
-        jobResult.DateFinished = DateTime.Now;
-        serializedjobResult.JobResult = jobResult;
-        serializedjobResult.SerializedJobResultData =
-          result;
-
-        jobResultAdapter.UpdateSerializedJobResult(serializedjobResult);
+        
+        DaoLocator.JobDao.Update(job.JobInfo);
 
         response.Success = true;
         response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_JOBRESULT_RECEIVED;
         response.JobId = jobId;
-        response.finished = finished;
-        response.JobResultId = jobResult.Id;
+        response.finished = finished;        
                 
-        tx.Commit();
         HiveLogger.Info(this.ToString() + " ProcessJobResult: END Job received for Storage - SUB method: " + jobId);        
         return response;
-      }
-      catch (Exception ex) {
-        if (tx != null)
-          tx.Rollback();
-        throw ex;
-      }
-      finally {
-        if (session != null)
-          session.EndSession();
-      }
+
     }
 
@@ -780,15 +676,15 @@
       HiveLogger.Info("Client logged out " + clientId);
       
-      ISession session = factory.GetSessionForCurrentThread();
+      /*ISession session = factory.GetSessionForCurrentThread();
       ITransaction tx = null;
 
       try {
         IClientAdapter clientAdapter =
-          session.GetDataAdapter<ClientInfo, IClientAdapter>();
+          session.GetDataAdapter<ClientDto, IClientAdapter>();
         IJobAdapter jobAdapter =
-          session.GetDataAdapter<Job, IJobAdapter>();
+          session.GetDataAdapter<JobDto, IJobAdapter>();
 
         tx = session.BeginTransaction();
-
+           */
         Response response = new Response();
 
@@ -798,5 +694,5 @@
         heartbeatLock.ExitWriteLock();
 
-        ClientInfo client = clientAdapter.GetById(clientId);
+      ClientDto client = DaoLocator.ClientDao.FindById(clientId);
         if (client == null) {
           response.Success = false;
@@ -806,6 +702,6 @@
         if (client.State == State.calculating) {
           // check wich job the client was calculating and reset it
-          ICollection<Job> jobsOfClient = jobAdapter.GetJobsOf(client);
-          foreach (Job job in jobsOfClient) {
+          IEnumerable<JobDto> jobsOfClient = DaoLocator.JobDao.FindActiveJobsOfClient(client);
+          foreach (JobDto job in jobsOfClient) {
             if (job.State != State.finished)
               jobManager.ResetJobsDependingOnResults(job);
@@ -814,12 +710,12 @@
 
         client.State = State.offline;
-        clientAdapter.Update(client);
+        DaoLocator.ClientDao.Update(client);
 
         response.Success = true;
         response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_LOGOUT_SUCCESS;
 
-        tx.Commit();
+        //tx.Commit();
         return response;
-      }
+      } /*
       catch (Exception ex) {
         if (tx != null)
@@ -831,5 +727,5 @@
           session.EndSession();
       }
-    }
+    }     */
 
     /// <summary>
@@ -840,14 +736,14 @@
     /// <returns></returns>
     public Response IsJobStillNeeded(Guid jobId) {
-      ISession session = factory.GetSessionForCurrentThread();
+      /*ISession session = factory.GetSessionForCurrentThread();
       ITransaction tx = null;
 
       try {
         IJobAdapter jobAdapter =
-          session.GetDataAdapter<Job, IJobAdapter>();
-        tx = session.BeginTransaction();
+          session.GetDataAdapter<JobDto, IJobAdapter>();
+        tx = session.BeginTransaction();                */
 
         Response response = new Response();
-        Job job = jobAdapter.GetById(jobId);
+      JobDto job = DaoLocator.JobDao.FindById(jobId);
         if (job == null) {
           response.Success = false;
@@ -867,12 +763,12 @@
         }
 
-        jobAdapter.Update(job);
+        DaoLocator.JobDao.Update(job);
 
         response.Success = true;
         response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_SEND_JOBRESULT;
-        tx.Commit();
+        //tx.Commit();
         return response;
       }
-      catch (Exception ex) {
+      /*catch (Exception ex) {
         if (tx != null)
           tx.Rollback();
@@ -883,9 +779,9 @@
           session.EndSession();
       }
-    }
-
-    public ResponsePlugin SendPlugins(List<HivePluginInfo> pluginList) {
+    }   */
+
+    public ResponsePlugin SendPlugins(List<HivePluginInfoDto> pluginList) {
       ResponsePlugin response = new ResponsePlugin();
-      foreach (HivePluginInfo pluginInfo in pluginList) {
+      foreach (HivePluginInfoDto pluginInfo in pluginList) {
         // TODO: BuildDate deleted, not needed???
         // TODO: Split version to major, minor and revision number
@@ -893,5 +789,5 @@
           if (currPlugin.Name == pluginInfo.Name) {
 
-            CachedHivePluginInfo currCachedPlugin = new CachedHivePluginInfo {
+            CachedHivePluginInfoDto currCachedPlugin = new CachedHivePluginInfoDto {
               Name = currPlugin.Name,
               Version = currPlugin.Version.ToString(),
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientFacade.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientFacade.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientFacade.cs	(revision 3011)
@@ -1,3 +1,3 @@
-﻿#region License Information
+#region License Information
 /* HeuristicLab
  * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -46,5 +46,5 @@
     #region IClientCommunicator Members
 
-    public Response Login(ClientInfo clientInfo) {
+    public Response Login(ClientDto clientInfo) {
       return clientCommunicator.Login(clientInfo);
     }
@@ -58,7 +58,7 @@
     }
 
-    public ResponseSerializedJob SendSerializedJob(Guid clientId) {
+    /*public ResponseSerializedJob SendSerializedJob(Guid clientId) {
       return clientCommunicator.SendSerializedJob(clientId);
-    }
+    } */
 
     public ResponseResultReceived StoreFinishedJobResult(Guid clientId,
@@ -78,5 +78,5 @@
     }
 
-    public ResponsePlugin SendPlugins(List<HivePluginInfo> pluginList) {
+    public ResponsePlugin SendPlugins(List<HivePluginInfoDto> pluginList) {
       return clientCommunicator.SendPlugins(pluginList);
     }
@@ -120,5 +120,5 @@
     }
 
-    public Stream SendStreamedPlugins(List<HivePluginInfo> pluginList) {
+    public Stream SendStreamedPlugins(List<HivePluginInfoDto> pluginList) {
       return
         new StreamedObject<ResponsePlugin>(
